#
# Std-Template for C++ -Source generation
# By Robbert van Leeuwen 1998
# 


BEGIN@DATA
/*@**************************************************************************\
*
*
*  WARNING : THIS FILE IS GENERATED BY @USER AT @DATE @TIME
*  WITH STD (c) FROM FILE : @SRC
*
* (c) Copyright 
*
* $Workfile:   @FNAME  $
*
* $Module: @MODUP
*
*
\**************************************************************************@*/


#include "@FHEADER"


typedef enum 
{ 
  @EXEC_STATES  
} STATE;


char *TThread::state_name[]=
{
@STATE_NAMES
};


void @MODULE::Run()
{
   switch (GetState())
    {
@INSERT_EXEC_BODY
     }
}

END@DATA


BEGIN@DFDDATA
/*@**************************************************************************\
*
*
*  WARNING : THIS FILE IS GENERATED BY @USER AT @DATE @TIME
*  WITH STD (c) FROM FILE : @SRC
*
* (c) Copyright 
*
* $Workfile:   @FNAME  $
*
* $Module: @MODUP
*
*
\**************************************************************************@*/



#include <stdio.h>
#include <conio.h>
#include "tmaster.h"
@INCLUDES

void main()
{
	
	 //Create threads
  new TMaster("master");
@CREATE_THREADS

  CSystem *system=dynamic_cast<CSystem*>(Thread("SYSTEM"));
  assert(system);

	 //Create system I/O
@SYSTEM_IO	

	 //Links thread I/O

@LINKS


	 //Schedule the system
	 while(true) system->Run();
		   
}

END@DFDDATA

BEGIN.STD

  #####################################################################################################################
  #Forward definitions
  #
  &FUNC ParseTransitorial(level);  

  #####################################################################################################################
  #Generate tab inserts 
  &FUNC TabIns(level)
  [t]
  {
    t=copy("\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t",0,level)
  }
  RETURN(t)

  #####################################################################################################################
  #Generate code for normal transition
  #
  &FUNC GetNormalTrans(level)
  [s]
  {
    s=""
    StdError((ctrans()=="")&(NxtStatCnt()<>1)&(cstate()<>"T")&(cstate()<>nstate()),"State ["+cstate()+"] can not contain more trans by default trans")
    IF(cstate()<>nstate())
    {
      TransitTo=copy(nstate(),1,1)
      s=s+TabIns(level+1)+"SetNextState("+uscore(nstate())+");\n"
      s=s+TabIns(level+1)+"break;\n"
    }
  }
  return(s)

  #####################################################################################################################
  #Generate code for an action
  #
  &FUNC GetAction(level)
  [s,t]
  {
    t=TabIns(level+1)
    s=""
    ForEach:Action
    {
      IF(caction()<>"")
      {
          s=s+t+caction()+";\n"
      }
    }

    if(nstate()=="T")
    {
      PushStdData()
      ZoomState()
      ForEach:Trans
      {
        s=s+ParseTransitorial(level+1)
      }
      PopStdData() 
    }
    else
    {
      s=s+GetNormalTrans(level)
    }

  }
  return(s)

  #####################################################################################################################
  #Generate code for a condition
  #
  &FUNC GetCondition(level)
  [s,t]
  {
    t=TabIns(level)
    s=""
    if(alltrim(ctrans())<>"")
    {
      s=s+t+"if ( "+SR(SR(ctrans(),"\n",""),"\r","")+" )\n"
      s=s+t+"{\n"
      s=s+GetAction(level)
      s=s+t+"}\n"
    }
    else
    { 
       s=s+GetAction(level-1)
    }
  }
  return(s)

  #####################################################################################################################
  #Generate code for a transitorial
  #
  &FUNC ParseTransitorial(level)
  [s]
  {
    if(cstate()=="T")
    {
      StdError(!ContainsDefTrans(),"Transitorial should contain one default transition "+cthread())
    }

    s=GetCondition(level)
  }
  return(s)



  # Read module name from STD info block
 
  status("Combining STD data ")

  ForEach:Thread
  {
      #Reset variables for combining data
      IB=""
      rstate()
      states=""
      state_names=" "
      first=TRUE
      ForEach:State
      {
        IF(cstate()<>"T")
		       {
          # If not first state of thread then put a "," and a CR/LF
          IF(!first) 
          {
              states=states+",\n  "
              state_names=state_names+",\n "
          }
          first=FALSE
          state_names=state_names+"\""+cstate()+"\""
          state=sr(uscore(cstate()),"#","")
          states=states+state
        
          IB=IB+"\f\n"
          IB=IB+"\t\t/***********************************************\n"
          IB=IB+"\t\t *\n"
          IB=IB+"\t\t * State       :"+state+"\n"
          IB=IB+"\t\t * Description :"+Dstate()+"\n"
          IB=IB+"\t\t * Prev states :"+sr(uscore(PrvStateList()),"#","")+"\n"
          IB=IB+"\t\t * Next states :"+sr(uscore(NxtStateList()),"#","")+"\n"
          IB=IB+"\t\t *\n"
          IB=IB+"\t\t/**********************************************/\n"
          IB=IB+"\t\tcase "+state+":\n"
          ForEach:Trans
          {
            IB=IB+ParseTransitorial(3)
          }
          IB=IB+"\t\t\tbreak;\n"
         }
      }
      RunError(states=="","Please select a state in your STD\nWith a 'First state of thread @EXEC'")
  
      status("Converting input hdr file to ",cthread())
      s=data
      s=sr(s,"@FHEADER",cthread()+".h")
      s=sr(s,"@FNAME",cthread())
      s=sr(s,"@MODUP",cthread())
      s=sr(s,"@MODLOW",cthread())
      s=sr(s,"@EXEC_STATES",states)
      s=sr(s,"@STATE_NAMES",state_names)
      s=sr(s,"@MODULE",cthread())
      s=sr(s,"@INSERT_EXEC_BODY",IB)
      s=sr(s,"@USER",GetUser())
      s=sr(s,"@DATE",date())
      s=sr(s,"@TIME",time())
      s=sr(s,"@SRC",CurPath()+CurFile()+".STD")
      s=sr(s,"@STATICS",StdData())
      s=sr(s,"TThread",cthread())
      s=sr(s,"\n","\r\n")
      fname=CurPath()+cthread()+".cpp"
      writefile(fname,s)
      status("File :",fname," ready...")

  }
END.STD







BEGIN.DFD
  fname=CurPath()+CurFile()+".cpp"
  s=DfdData

  ForEach:Proc
  {
     i=find(cproc(),":")     
     instance=copy(cproc(),0,i-2)
     class=copy(cproc(),i+1,len(cproc()))

     s=SR(s,"@INCLUDES","#include \""+class+".h\"\n"+"@INCLUDES")
     s=SR(s,"@CREATE_THREADS","\tnew "+class+"(\""+instance+"\");\n"+"@CREATE_THREADS")
     ForEach:Flow
     {
       link="\t*(Thread(\"@T2\")->Input(\"@INPUT\"))=Thread(\"@T1\")->Output(\"@OUTPUT\");\n"
       i=find(cflow(),">>")
       output=copy(cflow(),0,i)      
       input=copy(cflow(),i+2,len(cflow()))
       t1=instance
       i=find(nobjname(),":")          
       t2=copy(nobjname(),0,i-2)
       class2=copy(nobjname(),i+1,len(nobjname()))
       link=SR(link,"@T1",t1)
       link=SR(link,"@T2",t2)
       link=SR(link,"@INPUT",input)
       link=SR(link,"@OUTPUT",output)
       s=SR(s,"@LINKS",link+"@LINKS")
       if(class=="CSystem")
       {
         sysio="\tsystem->CreateOutput(\"@OUT\",NULL);\n"
         sysio=sr(sysio,"@OUT",output)
         s=sr(s,"@SYSTEM_IO",sysio+"@SYSTEM_IO")
       }
       if(class2=="CSystem")
       {
         sysio="\tsystem->CreateInput(\"@IN\",NULL);\n"
         sysio=sr(sysio,"@IN",input)
         s=sr(s,"@SYSTEM_IO",sysio+"@SYSTEM_IO")
       }
     }     

  }
  s=SR(s,"@INCLUDES","")
  s=SR(s,"@CREATE_THREADS","")
  s=SR(s,"@LINKS","")
  s=sr(s,"@SYSTEM_IO","")
  writefile(fname,s)
END.DFD