#
# Std-Template for Multiprog -ST generation
# By Robbert van Leeuwen 2007
# 


BEGIN@STATELIST
END@STATELIST


BEGIN@HEADER
dim @MODUPState
dim @MODUPPrevState
@USRDATA
@SUBTHREADDATA
END@HEADER

BEGIN@SUBHEADER
while 1 do
@SUBS
endwhile
end
END@SUBHEADER

BEGIN@DATA
sub @MODUP
  rem *  WARNING : THIS FILE IS GENERATED BY @USER AT @DATE @TIME
  rem *  WITH STD (c) FROM FILE : @SRC
  rem *
  rem * (c) Copyright http://www.dSea.nl
  rem *
  rem * $Module: @MODUP
  rem *
@INSERT_EXEC_BODY
endsub

END@DATA


BEGIN@UNITREADY
END@UNITREADY

BEGIN@IB
END@IB


BEGIN.STD


  &FUNC TabIns(level)
  [t]
  {
    t=copy("\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t",0,level)
  }
  RETURN(t)

  &FUNC GetNormalTrans(level)
  [s,stateName,sNum]
  {
    s=""
    
    StdError((ctrans()=="")&(NxtStatCnt()<>1)&(cstate()<>"T")&(cstate()<>nstate()),"State ["+cstate()+"] can not contain more trans by default trans")


    IF(cstate()<>nstate())
    {
      stateName=sr(nstate(),">","")
      sNum=GetItem("@"+stateName+"=",stateList)
      StdError(sNum=="","Invalid transition to state ["+stateName+"]")
      s=s+TabIns(level)+"print \""+cthread()+": "+cstate()+"=>"+stateName+"\"\n"
      s=s+TabIns(level)+"let @MODUPState="+sNum+"\n"
      s=s+TabIns(level)+"return\n"
    }
  }
  return(s)




  &FUNC GetAction(level)
  [s,t]
  {
    t=TabIns(level)
    s=""
    ForEach:Action
    {
      IF(caction()<>"")
        BEGIN
          s=s+t+caction()+"\n"
        END
    }
  }
  return(s)

  &FUNC GetCondition(level)
  [s,t]
  {
    s=""
    if(alltrim(ctrans())<>"")
    {
      t=TabIns(level)
      s=s+t+"if("+SR(SR(ctrans(),"\n",""),"\r"," ")+" ) then\n"
    }
  }
  return(s)

  &FUNC Transitorial(level)
  [s,action]
  {

    if(cstate()=="T")
    {
      StdError(!ContainsDefTrans(),"Transitorial should contain one default transition "+cthread())
    }

    s=GetCondition(level)

    IF(ctrans()<>"")
    {
       level=level+1
    }

    action=GetAction(level)
    s=s+action
    if(nstate()=="T")
    {
      PushStdData()
      ZoomState()
      ForEach:Trans
      {
        s=s+Transitorial(level)
      }
      PopStdData() 
    }
    else
    {
      s=s+GetNormalTrans(level)
    }

    IF(ctrans()<>"") 
    {
      s=s+TabIns(level-1)+"endif\n"
    }
  }
  return(s)


  &FUNC ParseTransitorial(level)
  [s]
  {
    s=Transitorial(level)
  }
  return(s)




  # Read module name from STD info block
 
  status("Combining STD data ")

 

  out=""
  top="auto\n"
  subs=""
  

  ForEach:Thread
  {
      subs=subs+"  gosub "+cthread()+"\n"

      STATELIST=""
      #Reset variables for combining data
      IB=""
      rstate()
      states=""
      state_names=" "
      first=TRUE

      stateList=""
      i=0
      ForEach:State
      {
        IF((cstate()<>"T") &(copy(cstate(),0,1)<>">"))
        {
          stateList=stateList+"@"+cstate()+"="+itos(i)+"\r"
          i=i+1
        }
      }

      ForEach:State
      {
        IF((cstate()<>"T") &(copy(cstate(),0,1)<>">"))
        {
           # If not first state of thread then put a "," and a CR/LF
           IF(!first) 
           {
              states=states+",\n  "
              state_names=state_names+",\n "
           }
           first=FALSE
           state_names=state_names+"\""+cstate()+"\""
           state=sr(uscore(cstate()),"#","")
           states=states+state
           IB=IB+"\trem \n"
           IB=IB+"\trem *************************************************************\n"        
           IB=IB+"\trem State       :"+state+"("+GetItem("@"+state+"=",stateList)+")\n"
           IB=IB+"\trem Description :"+Dstate()+"\n"
           IB=IB+"\trem Prev states :"+sr(uscore(PrvStateList()),"#","")+"\n"
           IB=IB+"\trem Next states :"+sr(uscore(NxtStateList()),"#","")+"\n"
           IB=IB+"\tif(@MODUPState=="+GetItem("@"+state+"=",stateList)+") then\n"
          
           ForEach:Trans
           {
             IB=IB+ParseTransitorial(2)
           }
           IB=IB+"\tendif\n"
          
          }
      }

      RunError(states=="","Please select a state in your STD\nWith a 'First state of thread @EXEC'")
      s=data
      s=sr(s,"@INSERT_EXEC_BODY",IB)
      s=sr(s,"@FNAME",cthread())
      dTop=header
      dTop=sr(dTop,"@MODUP",cthread())
      dTop=sr(dTop,"@SUBTHREADDATA",subthreaddata())
      top=top+dTop
      s=sr(s,"@MODUP",cthread())
      s=sr(s,"@USER",GetUser())
      s=sr(s,"@DATE",date())
      s=sr(s,"@TIME",time())
      s=sr(s,"@SRC",CurPath()+CurFile()+".STD")  

      out=out+s

   }
   subs=copy(subs,0,len(subs)-1)
   out=top+subheader+out
   out=sr(out,"@USRDATA",GetusrData())
   out=sr(out,"@SUBS",subs)
   out=sr(out,"\r\n","\n")
   out=out+"\n\n\n"
   out=sr(out,"\t","  ")
   out=sr(out,"\n","\r\n")

   fname=CurPath()+cthread()+".SOS"
   writefile(fname,out)
   status("File :",fname," ready...")
   ToClipboard(out)
END.STD